<template>
  <v-card>
    <v-toolbar dark color="success">
        <v-btn icon dark @click.native="close">
            <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-toolbar-title>Your Donations</v-toolbar-title>
    </v-toolbar>
    <v-divider></v-divider>
    <v-container fluid>
        <div v-if="countDonations===0">
            <v-alert
                outlined
                color="warning"
                icon="mdi-donation-off"
            >
                Anda belum memiliki daftar donasi yang belum dibayar
            </v-alert>
        </div>
        <v-list three-line v-if="countDonations>0">
            <template v-for="(item, index) in donations" >
                <v-list-item
                :key="'donation'+index"
                >
                <v-list-item-avatar>
                    <v-img :src="item.campaign.image"></v-img>
                </v-list-item-avatar>

                <v-list-item-content>
                    <v-list-item-title v-html="item.campaign.title"></v-list-item-title>
                    <v-list-item-subtitle>
                         Rp. {{ item.donation_amount.toLocaleString('id-ID') }}  
                       
                    </v-list-item-subtitle>
                </v-list-item-content>

                 <v-list-item-avatar  @click.stop="removeDonation(item)">
                    <v-icon size="40" dark color="error">mdi-delete-circle</v-icon>
                </v-list-item-avatar>
                
                </v-list-item>
            </template>                
        </v-list>
        <v-card v-if="countDonations>0">
          <v-card-text>
            <v-layout wrap>
              <v-flex pa-1 xs6>
              
                <span class="title">Rp. {{ this.totalDonations.toLocaleString('id-ID') }}</span>
                
              </v-flex>
              <v-flex pa-1 xs6 text-right>
                <v-btn color="primary" @click="pay" >
                      <v-icon>mdi-donation-arrow-right</v-icon> &nbsp;
                      Bayar 
                  </v-btn>
              </v-flex>
            </v-layout>
          </v-card-text>
        </v-card>
    </v-container>
  </v-card>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
export default {
  name: 'donation',
  computed: {
    ...mapGetters({
      donations       : 'donation/donations',
      countDonations  : 'donation/count',
      totalDonations  : 'donation/totalDonations',
      user            : 'auth/user',
      guest           : 'auth/guest',
    }),
  },
  methods: {
      ...mapActions({
        setAlert        : 'alert/set',       
        removeDonation  : 'donation/remove',
      }),
      pay(){
        let formData = {
          'totalDonations'  : this.totalDonations,
          'user_id'         : this.guest ? '' : this.user.user.id,
          'donations'       : this.donations
        }

         axios.post('/api/donation/pay' , formData)
          .then((response) => {
            let { data } = response.data
            snap.pay(data.token, {
              onSuccess: function(result){console.log('success');console.log(result);},
              onPending: function(result){console.log('pending');console.log(result);},
              onError: function(result){console.log('error');console.log(result);},
              onClose: function(){console.log('customer closed the popup without finishing the payment');}
            })
          })
          .catch((error) => {
            console.log(error)
          })

          
      },
      close() {
          this.$emit('closed', false)
      }
  },
}
</script>